/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  Accessor
  Package: conduits
  File:    Accessor.java
*/
package fi.hut.tcm.jacob.conduits;
/**
  Accessor
  
  Accessor defines an abstract interface for the Mux to obtain and 
  encapsulate Muxing information on Messages.
*/
public interface Accessor {

  /**
    Extracts or decodes a key value from a message for demultiplexing. 
    Called by Mux.mux when a message has arrived from side A, and should be 
    routed through side B.
  */
  public abstract Object getKey(Message message);
  
  
  
  
  /**
    Encodes or attaches demultiplexing information to a Message. Called by 
    Mux.mux when a message traverses from some side B towards side A. The 
    key is the particular key value attached to the Conduit the message is 
    arriving from.
  */
  public abstract void setKey(Message message, Object key);
  
  
  
  
  /**
  */
  public abstract void unsetKey(Message message);
  
  
  
  
} // Accessor


// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
