/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  Conduit
  Package: conduits
  File:    Conduit.java
*/
package fi.hut.tcm.jacob.conduits;
/**
  Conduit
  
  Conduit is an interface specifying the common behaviour for all conduits:
   Sessions, Muxes, Adaptors, ConduitFactories and Protocols.
*/
public interface Conduit {

  /**
  */
  public static final int A = 0;
  
  /**
  */
  public static final int B = 1;

  /**
  */
  public abstract Side getSide(int index);
  
  
  
  
  /**
  */
  public abstract int getSideCount();
  
  
  
  
  /**
  */
  public abstract Object clone()
    throws CloneNotSupportedException ;
  
  
  public abstract void dump();
  public abstract int getId();
  
} // Conduit


// +*************** UNUSED CODE ***************
//+ Conduit::clone( )
//- Conduit::clone( )
// -*************** UNUSED CODE ***************
