/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  Copyright (C) 1998 XYZ Corporation. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  Installer
  Package: conduits
  File:    Installer.java
*/

package fi.hut.tcm.jacob.conduits;

/**
  Installer
  
  
*/
public class Installer
  extends Object
  implements InstallMessenger, Messenger {

  /**
  */
  public static final Installer instance = new Installer();
  
  /* ****************** Interprets ************************/
  
  /**
  */

  /* ***************End of Interprets *********************/
  
  /**
  */
  private Installer() {
  
  //+ Installer::Installer( )
  //- Installer::Installer( )
  }
  
  /**
  */
  public Side getEndpoint(Message message, int index) {
  
  //+ Installer::getEndpoint(Message, int)
    InstallOob oob = (InstallOob)message.getOob();
    return oob.getEndpoint(index);
  //- Installer::getEndpoint(Message, int)
  }
  
  /**
  */
  public int getEndpointCount(Message message) {
  
  //+ Installer::getEndpointCount(Message)
    InstallOob oob = (InstallOob)message.getOob();
    return oob.getEndpointCount();
  //- Installer::getEndpointCount(Message)
  }
  
  /**
  */
  public Conduit getPrototype(Message message) {
  
  //+ Installer::getPrototype(Message)
    InstallOob oob = (InstallOob)message.getOob();
    return oob.getPrototype();
  //- Installer::getPrototype(Message)
  }
  
  /**
  */
  public Object getKey(Message message, int index) {
  
  //+ Installer::getKey(Message, int)
      InstallOob oob = (InstallOob)message.getOob();
      return oob.getKey(index);
  //- Installer::getKey(Message, int)
  }
  
  /**
  */
  public void apply(Message message, State state, Session session) {
  
  //+ Installer::apply(Message, State, Session)
    // Do nothing
  //- Installer::apply(Message, State, Session)
  }
  
} // Installer

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
