/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  XXX   %Z%%M% version %I% date:%G%
  Component:  Side
  Package: conduits
  File:    Side.java
*/

package fi.hut.tcm.jacob.conduits;

/**
  Side
  
  
*/
public interface Side {

  /**
  */
  public static final int A = Conduit.A;
  
  /**
  */
  public static final int B = Conduit.B;
  
  /**
  */
  public abstract void attach(Side next)
    throws SideException, IllegalArgumentException ;
  
  /**
  */
  public abstract Side detach();
  
  /**
  */
  public abstract void accept(Visitor visitor)
    throws ConductingException ;
  
  /**
  */
  public abstract Conduit getConduit();
  
  /**
  */
  public abstract Side getAttached();
  
  /**
  */
  public abstract Side getNext();
  
  /**
   */
  public abstract void setMessenger(Messenger msgr);

  /**
  */
  public abstract Object clone()
    throws CloneNotSupportedException ;

  /* Dumps the ID's of attached and opposite.attached,
     or 0 if not attached or N/A.
     */
  public abstract void dump();
  
} // Side

// +*************** UNUSED CODE ***************
//+ Side::getNext( )
//- Side::getNext( )
//+ Side::clone( )
//- Side::clone( )
// -*************** UNUSED CODE ***************
