/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  XXX   %Z%%M% version %I% date:%G%
  Component:  SimpleScheduler
  Package: conduits
  File:    SimpleScheduler.java
*/

package fi.hut.tcm.jacob.conduits;
import fi.hut.tcm.jacob.utility.Queue;
import fi.hut.tcm.jacob.utility.OrderedQueue;

/**
  SimpleScheduler
  
  Simple fifo scheduler.
*/
public class SimpleScheduler
  extends Object
  implements Scheduler {

  /**
    Implements Java Singleton Pattern.
  */
  public static final SimpleScheduler instance = new SimpleScheduler();
  
  /**
  */
  private TravellerThread traveller;
  
  /**
  */
  private Queue runQueue;
  
  /**
    Allocates an internal Queue and Thread for houskeeping. The queue holds
     runnable items. The Thread tries to empty the queue by running the 
    runnables in it.
  */
  private SimpleScheduler() {
  //+ SimpleScheduler::SimpleScheduler( )
    runQueue = new OrderedQueue(TimeoutQuery.instance);
    traveller = new TravellerThread(runQueue);

    // Thsese were missing at first:  XXX
    traveller.start();  
    Thread.currentThread().yield(); // XXX Bug in runtime environment?

  //- SimpleScheduler::SimpleScheduler( )
  }
  
  /**
    Adds given item to runQueue.
  */
  public void makeRunnable(Runnable item) {
  //+ SimpleScheduler::makeRunnable(Runnable)
    runQueue.put(item);
  //- SimpleScheduler::makeRunnable(Runnable)
  }
  
} // SimpleScheduler

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
