/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  State
  Package: conduits
  File:    State.java
*/
package fi.hut.tcm.jacob.conduits;
/**
  State
  
  A State is a generic interface for protocol specific states. Each 
  protocol implementation must provide its own set of state classes. 
  Typically all state classes use the Singleton pattern, making it 
  impossible to directly create new instances of them. Therefore we have 
  specified the instance() method at the interface level: the specific 
  State class may use or not to use the pattern.
*/
public interface State {

  /**
    Each state class must declare an independent, final
    <code>instance</code> class variable that is a reference to the only 
    instance of that particular class.
    All State constructors must be private.
  */
  public static State instance = null;
  
} // State


// +*************** UNUSED CODE ***************
//+ Side::detach(Side)
//- Side::detach(Side)
//+ Mux::detach(Object)
//- Mux::detach(Object)
// -*************** UNUSED CODE ***************
