/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  Terminator
  Package: conduits
  File:    Terminator.java
*/
package fi.hut.tcm.jacob.conduits;
/**
  Terminator
  
  Drops all messages that arrive.
*/
public final class Terminator
  extends Adaptor {

  /**
    Handles the received message by dropping it on the floor.
  */
  public void adapt(Message message) {
  
    //+ Terminator::adapt(Message)
    //- Terminator::adapt(Message)
  }
  
  public Object clone()
       throws CloneNotSupportedException  {
	 if(Debugger.level > 3)
	   System.out.println("Terminator.clone()");
	 // Cannot do this, because the superclass is Adaptor,
	 // which doesn't support cloning.
	 return super.clone();
  }
  
} // Terminator


// +*************** UNUSED CODE ***************
//+ Side::detach(Side)
//      Side side;
//      side = this.next;
//      this.next = null;
//      return side;
//- Side::detach(Side)
//+ Mux::detach(Object)
//- Mux::detach(Object)
// -*************** UNUSED CODE ***************
