/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  Uninstaller
  Package: conduits
  File:    Uninstaller.java
*/
package fi.hut.tcm.jacob.conduits;
/**
  Uninstaller
  
  This class implements the abstract class UninstallMessenger.
  If you use an Uninstaller object as a messenger, you must
  use UninstallOob as the out of band object of the message.
*/
public final class Uninstaller
  extends Object
  implements UninstallMessenger, Messenger {

  /**
     Uninstaller is a singleton, get a reference from here.
  */
  public static final Uninstaller instance = new Uninstaller();
  
  /**
  */
  private Uninstaller()
    {
  
      //+ Uninstaller::Uninstaller( )
      //- Uninstaller::Uninstaller( )
    }
  
  /**
   */
  public Conduit getConduit(Message message)
    {
      //+ Uninstaller::getConduit(Message)
      UninstallOob oob = (UninstallOob)message.getOob();
      return oob.getConduit();
      //- Uninstaller::getConduit(Message)
    }
  
  
  /**
  */
  public void apply(Message message, State state, Session session)
    {
      
      //+ Uninstaller::apply(Message, State, Session)
      // Do nothing
      //- Uninstaller::apply(Message, State, Session)
    }
  
  
} // Uninstaller


// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
