/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  Visitor
  Package: conduits
  File:    Visitor.java
*/
package fi.hut.tcm.jacob.conduits;
/**
  Visitor
  
  A visitor is an abstract interface that allows Transporters and other 
  classes to traverse the conduit graph. Whenever someone calls a conduit's
   accept() method handing it a visitor, the conduit indicates its specific
   type by calling an appropriate at() method of the visiting visitor.
*/
public interface Visitor
  extends Runnable {

  /**
  */
  public abstract void at(Mux mux, Side at);
  
  
  
  
  /**
  */
  public abstract void at(Session session, Side at);
  
  
  
  
  /**
  */
  public abstract void at(ConduitFactory factory, Side at);
  
  
  
  
  /**
  */
  public abstract void at(Adaptor adaptor, Side at);
  
  
  
  
} // Visitor


// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
