/*
  Copyright (c) 1998 Helsinki University of Technology.
  All rights reserved.

  Redistribution and use in source and binary forms are permitted
  provided that the above copyright notice and this paragraph are
  duplicated in all such forms and that any documentation,
  advertising materials, and other materials related to such
  distribution and use acknowledge that the software was developed
  by Helsinki University of Technology, Espoo.  The name of the
  University may not be used to endorse or promote products derived
  from this software without specific prior written permission.
  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
  Copyright (c) 1998 Pekka Nikander & Juha Parssinen
  All rights reserved.
  XXX   %Z%%M% version %I% date:%G%
  Module:  OrderedStorage
  Package: utility
  File:    OrderedStorage.java
*/
package fi.hut.tcm.jacob.utility;
/**
  OrderedStorage
  
  The common interface of sorted storages.
*/
public interface OrderedStorage
  extends Storage {

  /**
    Removes given object from storage and returns reference to it. If item 
    doesn't found returns null.
  */
  public abstract Object take(Object item);
  
  
  
  
  /**
    Returns reference to item which have highest key (i.e. priority). 
    Returns null if storage is empty.
  */
  public abstract Object get();
  
  
  
  
} // OrderedStorage


